This document covers how to use ROKU streaming sensors inside the integrators application.

* Unzip the kantarmedia-streaming-roku zip file and copy all the files into components folder.
* Please select the scenegraph component in which you have video node embedded.
* Include KMASpringStreams.brs file into scenegraph:

    <script type="text/brightscript" uri="pkg:/components/KMASpringStreams.brs"/>
    <script type="text/brightscript" uri="pkg:/components/KMAStream.brs"/>
    <script type="text/brightscript" uri="pkg:/components/KMAFunctions.brs"/>

* Please add functions and request task into children of scenegraph:

    <children>
    <KMARequest id ="KMARequest"/>
    <KMAFunctions id = "KMAFunctions"/>
    </children>

* Assign video node to variable KMAvideo since we use it to track the position inside the library:
    
    m.KMAVideo = m.top.findNode("videonode")

* Initialise sensor in the following way:

   m.sensor      = SpringStreams("<sitecode>")

* Parameters Explained:

    1. sitecode : Site code which should be used by the sensor for measurement. The site code is provided by the owner of the streaming solution.
    
* Once initialised please create the adapter with required information:
 
    m.ad = {
    "getMeta": {
                "pl": "TestPlayer",
                "plv": "1.0.0",
                "sx": m.video.width,
                "sy": m.video.height
            }
        "getPosition": CInt(m.video.position)
        "getDuration": m.video.duration
    }
    
    m.desc= {
        "sx": deviceInfo.GetDisplaySize().w,
        "sy": deviceInfo.GetDisplaySize().h,
        "stream":  "STREAM NAME"
    }

    Beginning from SDK version 1.4.0, getPostion and getDuration methods have to be implemented as mandatory. They are now treated as methods instead of properties.
    If SDK receives zero as value for position or duration, It will read the values from the KMAVideo node reference.

    Here is how it looks from V-1.4.0.
    m.ad = {
        "globalM": m 'Getting reference of outer object
        "getMeta": {
            "pl": "TestPlayer",
            "plv": "1.0.0",
            "sx": m.KMAVideo.width,
            "sy": m.KMAVideo.height
        }
        "getPosition": function() as Integer 
            if(m.globalM.KMAVideo<>invalid)
                return CInt(m.globalM.KMAVideo.position)
            else
                return 0
            end if 
        end function
        "getDuration": function() as Integer
            if(m.globalM.KMAVideo<>invalid)
                return m.globalM.KMAVideo.duration
            else
                return 0
            end if
        end function
  }

* On start of video , call the track method of the sensor:

    m.sensor.track("testStream",m.desc,m.ad)

* When back is pressed or app is closed please call unload function of sensor:

    m.sensor.unload()

* When home button is used during video playback, the measurement will be stopped. No final request will be sent (expected behaviour due to platform limitations).

* Opt-Out

* The user can be given the ability to stop measurement of his actions if he wish to. 
    For this purpose please call below methods
    1. m.sensor.setTracking(boolean)
        value defaults to true
        When the value false is specified, the sending of requests to the measuring system is switched off
    2. m.sensor.isTracking()  
        returns true if tracking is enabled

* To retrieve the uid of the current stream, call the method (can only be used after method track is called):

    KMA_getUID()
    
 * Get nextUID
    A new method getNextUid() is added which will provide you with uid that is being measureed 
    m.nextUid= m.sensor.getNextUid()

 * trackWithUid
    Once you retrieve uid using above method , Please call trackWithUid() method that takes additional     parameter 'handle/uid'  
    m.sensor.trackWithUid("testStream",m.desc,m.ad,m.nextUid)     

 * Please note that old track method is still available and works in same manner    
