
REM     * The  Stream object will be returned when the method
REM     * SpringStreams.track(stream, atts, adapter) is called.
REM     * The method stop() can be called if the measurement should be
REM     * stopped. It is not possible to reactivate the measurement. For that
REM     * purpose the method SpringStreams.track(stream, atts, adapter) has to be
REM     * called again.
REM     * @param springstreams1 {SpringStreams} The collector
REM     * @param streamName
REM     *            {String} stream The name of the stream content
REM     * @param reqAtt
REM     *            {Map} att A map which contains information about the streaming
REM     *            content.
REM     * @param adapter
REM     *            {StreamAdapter} adapter The stream adapter which handles the
REM     *            access to the underlying streaming content.


function StreamClass(springstreams1 as object , streamName as object , reqAtt as object , adapterInst as object) as object
     m.clock = CreateObject("roDateTime")
     m.clock1 = CreateObject("roTimeSpan")
     generateUid = function()
          randomUidPart = stri(Int(rnd(4000000000) + m.clock.GetMilliseconds()),36)
          millisUidPart = strI((m.clock.AsSeconds() + m.clock.GetMilliseconds()),36)
          return millisUidPart + randomUidPart + strI(m.clock.GetMilliseconds(),36)
     end function

              m.id = springstreams1.nextUid
              springstreams1.nextUid = ""
              if(m.id ="")
                         m.id= generateUid()
              end if
     m.start = m.clock.AsSeconds()
     m.ns= CreateObject("roAssociativeArray")
     m.playStates =CreateObject("roArray",100,true)
     m.attributes =CreateObject("roAssociativeArray")
     m.state = [0, 0, strI(m.start,36)]
     'print m.state
     m.pause = 0
     m.lastSync = 0
     m.doSync = true '// initial sync
     m.closed = false
     m.adapter =CreateObject("roAssociativeArray")

     m.syncrate =0
     m.syncrates= createObject("roArray",50,true)
     m.syncratesIndex =0
     m.ct =0
     m.collector = springstreams1
     m.tempStates=0
     m.ns = streamName
     m.position = 0

     m.stAdapter = adapterInst
     if (type(adapterInst)<>invalid)
          m.adapter = adapterInst
     end if
     getAttributes = function(att as object)
          a = CreateObject("roAssociativeArray")
          for each attribute in att
               a[attribute] = att[attribute]
          end for
          return a
     end function
     m.attributes = getAttributes(reqAtt)
     m.playStates = createObject("roArray",50,true)

     m.playStates.push(m.state)
     m.syncratesIndex = 0
     m.syncrate = m.collector.syncrate
     m.syncrates = m.collector.config["2cnt.net"].syncrates
     'Default values
     screen = CreateObject("roDeviceInfo")
     dimensions = screen.GetDisplaySize()
     m.getMetaDefault={
          "pl": "Roku streaming player",
          "plv": "1.0",
          "sx": dimensions.w,
          "sy": dimensions.h
     }
     return m
end function

function KMA_getUID() as string
     return m.id
end function
